Index: src/molecule.cpp
===================================================================
--- src/molecule.cpp	(revision 3a0b3890298aafb5853dc67311a7ba037e2e94b4)
+++ src/molecule.cpp	(revision 5ae39c416dba574777f0f8f68e7e7f9cacd96a25)
@@ -192,5 +192,5 @@
   BondRescale = TopOrigin->type->HBondDistance[TopBond->BondDegree-1];
   if (BondRescale == -1) {
-    eLog() << Verbose(3) << "ERROR: There is no typical hydrogen bond distance in replacing bond (" << TopOrigin->Name << "<->" << TopReplacement->Name << ") of degree " << TopBond->BondDegree << "!" << endl;
+    eLog() << Verbose(1) << "There is no typical hydrogen bond distance in replacing bond (" << TopOrigin->Name << "<->" << TopReplacement->Name << ") of degree " << TopBond->BondDegree << "!" << endl;
     return false;
     BondRescale = bondlength;
@@ -235,5 +235,5 @@
             SecondOtherAtom = (*Runner)->GetOtherAtom(TopOrigin);
           } else {
-            Log() << Verbose(3) << "WARNING: Detected more than four bonds for atom " << TopOrigin->Name;
+            eLog() << Verbose(2) << "Detected more than four bonds for atom " << TopOrigin->Name;
           }
         }
@@ -272,5 +272,5 @@
       bondangle = TopOrigin->type->HBondAngle[1];
       if (bondangle == -1) {
-        Log() << Verbose(3) << "ERROR: There is no typical hydrogen bond angle in replacing bond (" << TopOrigin->Name << "<->" << TopReplacement->Name << ") of degree " << TopBond->BondDegree << "!" << endl;
+        eLog() << Verbose(1) << "There is no typical hydrogen bond angle in replacing bond (" << TopOrigin->Name << "<->" << TopReplacement->Name << ") of degree " << TopBond->BondDegree << "!" << endl;
         return false;
         bondangle = 0;
@@ -394,5 +394,5 @@
       break;
     default:
-      eLog() << Verbose(0) << "ERROR: BondDegree does not state single, double or triple bond!" << endl;
+      eLog() << Verbose(1) << "BondDegree does not state single, double or triple bond!" << endl;
       AllWentWell = false;
       break;
@@ -445,5 +445,5 @@
     Walker->type = elemente->FindElement(shorthand);
     if (Walker->type == NULL) {
-      eLog() << Verbose(0) << "Could not parse the element at line: '" << line << "', setting to H.";
+      eLog() << Verbose(1) << "Could not parse the element at line: '" << line << "', setting to H.";
       Walker->type = elemente->FindElement(1);
     }
@@ -541,5 +541,5 @@
     add(Binder, last);
   } else {
-    eLog() << Verbose(1) << "ERROR: Could not add bond between " << atom1->Name << " and " << atom2->Name << " as one or both are not present in the molecule." << endl;
+    eLog() << Verbose(1) << "Could not add bond between " << atom1->Name << " and " << atom2->Name << " as one or both are not present in the molecule." << endl;
   }
   return Binder;
@@ -619,5 +619,5 @@
     AtomCount--;
   } else
-    eLog() << Verbose(0) << "ERROR: Atom " << pointer->Name << " is of element " << pointer->type->Z << " but the entry in the table of the molecule is 0!" << endl;
+    eLog() << Verbose(1) << "Atom " << pointer->Name << " is of element " << pointer->type->Z << " but the entry in the table of the molecule is 0!" << endl;
   if (ElementsInMolecule[pointer->type->Z] == 0)  // was last atom of this element?
     ElementCount--;
@@ -637,5 +637,5 @@
     ElementsInMolecule[pointer->type->Z]--; // decrease number of atom of this element
   else
-    eLog() << Verbose(0) << "ERROR: Atom " << pointer->Name << " is of element " << pointer->type->Z << " but the entry in the table of the molecule is 0!" << endl;
+    eLog() << Verbose(1) << "Atom " << pointer->Name << " is of element " << pointer->type->Z << " but the entry in the table of the molecule is 0!" << endl;
   if (ElementsInMolecule[pointer->type->Z] == 0)  // was last atom of this element?
     ElementCount--;
Index: src/molecule.hpp
===================================================================
--- src/molecule.hpp	(revision 3a0b3890298aafb5853dc67311a7ba037e2e94b4)
+++ src/molecule.hpp	(revision 5ae39c416dba574777f0f8f68e7e7f9cacd96a25)
@@ -106,4 +106,5 @@
 
   // re-definition of virtual functions from PointCloud
+  const char * const GetName() const;
   Vector *GetCenter() const ;
   TesselPoint *GetPoint() const ;
Index: src/molecule_dynamics.cpp
===================================================================
--- src/molecule_dynamics.cpp	(revision 3a0b3890298aafb5853dc67311a7ba037e2e94b4)
+++ src/molecule_dynamics.cpp	(revision 5ae39c416dba574777f0f8f68e7e7f9cacd96a25)
@@ -307,5 +307,5 @@
     if (Params.DoubleList[i] > 1) {
       eLog() << Verbose(0) << "Failed to create an injective PermutationMap!" << endl;
-      exit(1);
+      performCriticalExit();
     }
   Log() << Verbose(1) << "done." << endl;
@@ -428,10 +428,10 @@
             }
             if (Potential > Params.PenaltyConstants[2]) {
-              eLog() << Verbose(0) << "ERROR: The two-step permutation procedure did not maintain injectivity!" << endl;
+              eLog() << Verbose(1) << "The two-step permutation procedure did not maintain injectivity!" << endl;
               exit(255);
             }
             //Log() << Verbose(0) << endl;
           } else {
-            eLog() << Verbose(0) << "ERROR: " << *Runner << " was not the owner of " << *Sprinter << "!" << endl;
+            eLog() << Verbose(1) << *Runner << " was not the owner of " << *Sprinter << "!" << endl;
             exit(255);
           }
@@ -569,8 +569,10 @@
     if (!Force.ParseMatrix(file, 0,0,0)) {
       eLog() << Verbose(0) << "Could not parse Force Matrix file " << file << "." << endl;
+      performCriticalExit();
       return false;
     }
     if (Force.RowCounter[0] != AtomCount) {
       eLog() << Verbose(0) << "Mismatch between number of atoms in file " << Force.RowCounter[0] << " and in molecule " << AtomCount << "." << endl;
+      performCriticalExit();
       return false;
     }
Index: src/molecule_fragmentation.cpp
===================================================================
--- src/molecule_fragmentation.cpp	(revision 3a0b3890298aafb5853dc67311a7ba037e2e94b4)
+++ src/molecule_fragmentation.cpp	(revision 5ae39c416dba574777f0f8f68e7e7f9cacd96a25)
@@ -111,4 +111,5 @@
         if (!testGraphInsert.second) {
           eLog() << Verbose(0) << "KeySet file must be corrupt as there are two equal key sets therein!" << endl;
+          performCriticalExit();
         }
       }
@@ -211,4 +212,5 @@
   } else {
     eLog() << Verbose(0) << "Unable to open " << line << " for writing keysets!" << endl;
+    performCriticalExit();
     status = false;
   }
@@ -368,4 +370,5 @@
     } else {
       eLog() << Verbose(0) << "Atom No. " << (*runner).second.first << " was not found in this molecule." << endl;
+      performCriticalExit();
     }
   }
@@ -441,5 +444,5 @@
     // transmorph graph keyset list into indexed KeySetList
     if (GlobalKeySetList == NULL) {
-      Log() << Verbose(1) << "ERROR: Given global key set list (graph) is NULL!" << endl;
+      eLog() << Verbose(1) << "Given global key set list (graph) is NULL!" << endl;
       return false;
     }
@@ -449,5 +452,5 @@
     map<int, pair<double,int> > *AdaptiveCriteriaList = ScanAdaptiveFileIntoMap(path, *IndexKeySetList); // (Root No., (Value, Order)) !
     if (AdaptiveCriteriaList->empty()) {
-      eLog() << Verbose(0) << "Unable to parse file, incrementing all." << endl;
+      eLog() << Verbose(2) << "Unable to parse file, incrementing all." << endl;
       while (Walker->next != end) {
         Walker = Walker->next;
@@ -638,5 +641,5 @@
         MolecularWalker->Leaf->FragmentBOSSANOVA(FragmentList[FragmentCounter], RootStack[FragmentCounter], MinimumRingSize);
       } else {
-        eLog() << Verbose(0) << "Subgraph " << MolecularWalker << " has no atoms!" << endl;
+        eLog() << Verbose(1) << "Subgraph " << MolecularWalker << " has no atoms!" << endl;
       }
       FragmentCounter++;  // next fragment list
@@ -898,5 +901,5 @@
       }
     } else {
-      Log() << Verbose(0) << "ERROR: Son " << Runner->Name << " has father " << FatherOfRunner->Name << " but its entry in SonList is " << SonList[FatherOfRunner->nr] << "!" << endl;
+      eLog() << Verbose(1) << "Son " << Runner->Name << " has father " << FatherOfRunner->Name << " but its entry in SonList is " << SonList[FatherOfRunner->nr] << "!" << endl;
     }
     if ((LonelyFlag) && (Leaf->AtomCount > 1)) {
@@ -1133,5 +1136,5 @@
         Log() << Verbose(0) << endl;
         //if (!CheckForConnectedSubgraph(FragmentSearch->FragmentSet))
-          //Log() << Verbose(0) << "ERROR: The found fragment is not a connected subgraph!" << endl;
+          //eLog() << Verbose(1) << "The found fragment is not a connected subgraph!" << endl;
         InsertFragmentIntoGraph(FragmentSearch);
       }
Index: src/molecule_graph.cpp
===================================================================
--- src/molecule_graph.cpp	(revision 3a0b3890298aafb5853dc67311a7ba037e2e94b4)
+++ src/molecule_graph.cpp	(revision 5ae39c416dba574777f0f8f68e7e7f9cacd96a25)
@@ -926,8 +926,12 @@
         break; // breaking here will not cause error!
     }
-    if (i == vertex->ListOfBonds.size())
+    if (i == vertex->ListOfBonds.size()) {
       eLog() << Verbose(0) << "Error: All Component entries are already occupied!" << endl;
-  } else
+      performCriticalExit();
+    }
+  } else {
     eLog() << Verbose(0) << "Error: Given vertex is NULL!" << endl;
+    performCriticalExit();
+  }
 }
 ;
@@ -1114,4 +1118,5 @@
   if (ReferenceStack->IsEmpty()) {
     eLog() << Verbose(0) << "ReferenceStack is empty!" << endl;
+    performCriticalExit();
     return false;
   }
Index: src/molecule_pointcloud.cpp
===================================================================
--- src/molecule_pointcloud.cpp	(revision 3a0b3890298aafb5853dc67311a7ba037e2e94b4)
+++ src/molecule_pointcloud.cpp	(revision 5ae39c416dba574777f0f8f68e7e7f9cacd96a25)
@@ -13,4 +13,11 @@
 /************************************* Functions for class molecule *********************************/
 
+/** Returns a name for this point cloud, here the molecule's name.
+ * \return name of point cloud
+ */
+const char * const molecule::GetName() const
+{
+  return name;
+};
 
 /** Determine center of all atoms.
Index: src/moleculelist.cpp
===================================================================
--- src/moleculelist.cpp	(revision 3a0b3890298aafb5853dc67311a7ba037e2e94b4)
+++ src/moleculelist.cpp	(revision 5ae39c416dba574777f0f8f68e7e7f9cacd96a25)
@@ -311,5 +311,5 @@
   Tesselation *TesselStruct = NULL;
   if ((srcmol == NULL) || (mol == NULL)) {
-    Log() << Verbose(1) << "ERROR: Either fixed or variable molecule is given as NULL." << endl;
+    eLog() << Verbose(1) << "Either fixed or variable molecule is given as NULL." << endl;
     return false;
   }
@@ -319,5 +319,5 @@
   FindNonConvexBorder(mol, TesselStruct, (const LinkedCell *&)LCList, 4., NULL);
   if (TesselStruct == NULL) {
-    Log() << Verbose(1) << "ERROR: Could not tesselate the fixed molecule." << endl;
+    eLog() << Verbose(1) << "Could not tesselate the fixed molecule." << endl;
     return false;
   }
@@ -402,6 +402,6 @@
   input.open(line.c_str());
   if (input == NULL) {
-    eLog() << Verbose(0) << endl << "Unable to open " << line << ", is the directory correct?"
-        << endl;
+    eLog() << Verbose(0) << endl << "Unable to open " << line << ", is the directory correct?" << endl;
+    performCriticalExit();
     return false;
   }
@@ -442,4 +442,5 @@
     if (input == NULL) {
       eLog() << Verbose(0) << endl << "Unable to open " << line << ", is the directory correct?" << endl;
+      performCriticalExit();
       return false;
     }
@@ -643,6 +644,8 @@
     if (path != NULL)
       strcpy(PathBackup, path);
-    else
+    else {
       eLog() << Verbose(0) << "OutputConfigForListOfFragments: NULL default path obtained from config!" << endl;
+      performCriticalExit();
+    }
 
     // correct periodic
@@ -757,8 +760,15 @@
   // 4a. create array of molecules to fill
   const int MolCount = Subgraphs->next->Count();
+  char number[MAXSTRINGSIZE];
   molecule **molecules = Malloc<molecule *>(MolCount, "config::Load() - **molecules");
   for (int i=0;i<MolCount;i++) {
     molecules[i] = (molecule*) new molecule(mol->elemente);
     molecules[i]->ActiveFlag = true;
+    strncpy(molecules[i]->name, mol->name, MAXSTRINGSIZE);
+    if (MolCount > 1) {
+      sprintf(number, "-%d", i+1);
+      strncat(molecules[i]->name, number, MAXSTRINGSIZE - strlen(mol->name) - 1);
+    }
+    cout << "MolName is " << molecules[i]->name << endl;
     insert(molecules[i]);
   }
@@ -797,5 +807,5 @@
     }
   }
-  // 4d. we don't need to redo bonds, as they are connected subgraphs and still maintained their ListOfBonds, but we have to remove them from first..last list
+  // 4d. we don't need to redo bonds, as they are connected subgraphs and still maintain their ListOfBonds, but we have to remove them from first..last list
   bond *Binder = mol->first;
   while (mol->first->next != mol->last) {
Index: src/parser.cpp
===================================================================
--- src/parser.cpp	(revision 3a0b3890298aafb5853dc67311a7ba037e2e94b4)
+++ src/parser.cpp	(revision 5ae39c416dba574777f0f8f68e7e7f9cacd96a25)
@@ -159,4 +159,5 @@
   if (input == NULL) {
     eLog() << Verbose(0) << endl << "Unable to open " << name << ", is the directory correct?" << endl;
+    performCriticalExit();
     return false;
   }
@@ -179,6 +180,8 @@
   //Log() << Verbose(0) << line.str() << endl;
   //Log() << Verbose(0) << "ColumnCounter[" << MatrixNr << "]: " << ColumnCounter[MatrixNr] << "." << endl;
-  if (ColumnCounter[MatrixNr] == 0)
+  if (ColumnCounter[MatrixNr] == 0) {
     eLog() << Verbose(0) << "ColumnCounter[" << MatrixNr << "]: " << ColumnCounter[MatrixNr] << " from file " << name << ", this is probably an error!" << endl;
+    performCriticalExit();
+  }
   
   // scan rest for number of rows/lines
@@ -193,6 +196,8 @@
   }
   //Log() << Verbose(0) << "RowCounter[" << MatrixNr << "]: " << RowCounter[MatrixNr] << " from file " << name << "." << endl;
-  if (RowCounter[MatrixNr] == 0)
+  if (RowCounter[MatrixNr] == 0) {
     eLog() << Verbose(0) << "RowCounter[" << MatrixNr << "]: " << RowCounter[MatrixNr] << " from file " << name << ", this is probably an error!" << endl;
+    performCriticalExit();
+  }
 
   // allocate matrix if it's not zero dimension in one direction
@@ -226,5 +231,5 @@
     }
   } else {
-    eLog() << Verbose(0) << "ERROR: Matrix nr. " << MatrixNr << " has column and row count of (" << ColumnCounter[MatrixNr] << "," << RowCounter[MatrixNr] << "), could not allocate nor parse!" << endl; 
+    eLog() << Verbose(1) << "Matrix nr. " << MatrixNr << " has column and row count of (" << ColumnCounter[MatrixNr] << "," << RowCounter[MatrixNr] << "), could not allocate nor parse!" << endl; 
   }
   input.close();
@@ -428,4 +433,5 @@
               if (m > RowCounter[ KeySets.OrderSet[Order][CurrentFragment] ]) {
                 eLog() << Verbose(0) << "In fragment No. " << KeySets.OrderSet[Order][CurrentFragment]   << " current force index " << m << " is greater than " << RowCounter[ KeySets.OrderSet[Order][CurrentFragment] ] << "!" << endl;
+                performCriticalExit();
                 return false;
               }
@@ -471,4 +477,5 @@
     if (output == NULL) {
       eLog() << Verbose(0) << "Unable to open output energy file " << line.str() << "!" << endl;
+      performCriticalExit();
       return false;
     }
@@ -500,4 +507,5 @@
   if (output == NULL) {
     eLog() << Verbose(0) << "Unable to open output matrix file " << line.str() << "!" << endl;
+    performCriticalExit();
     return false;
   }
@@ -656,4 +664,5 @@
       if (j > RowCounter[MatrixCounter]) {
         eLog() << Verbose(0) << "Current force index " << j << " is greater than " << RowCounter[MatrixCounter] << "!" << endl;
+        performCriticalExit();
         return false;
       }
@@ -793,4 +802,5 @@
       if (j > RowCounter[MatrixCounter]) {
         eLog() << Verbose(0) << "Current hessian index " << j << " is greater than " << RowCounter[MatrixCounter] << ", where i=" << i << ", Order=" << Order << ", l=" << l << " and FragmentNr=" << FragmentNr << "!" << endl;
+        performCriticalExit();
         return false;
       }
@@ -800,4 +810,5 @@
           if (k > ColumnCounter[MatrixCounter]) {
             eLog() << Verbose(0) << "Current hessian index " << k << " is greater than " << ColumnCounter[MatrixCounter] << ", where m=" << m << ", j=" << j << ", i=" << i << ", Order=" << Order << ", l=" << l << " and FragmentNr=" << FragmentNr << "!" << endl;
+            performCriticalExit();
             return false;
           }
@@ -852,4 +863,5 @@
               if (m > RowCounter[ KeySets.OrderSet[Order][CurrentFragment] ]) {
                 eLog() << Verbose(0) << "In fragment No. " << KeySets.OrderSet[Order][CurrentFragment]   << " current row index " << m << " is greater than " << RowCounter[ KeySets.OrderSet[Order][CurrentFragment] ] << "!" << endl;
+                performCriticalExit();
                 return false;
               }
@@ -869,4 +881,5 @@
                   if (n > ColumnCounter[ KeySets.OrderSet[Order][CurrentFragment] ]) {
                     eLog() << Verbose(0) << "In fragment No. " << KeySets.OrderSet[Order][CurrentFragment]   << " current column index " << n << " is greater than " << ColumnCounter[ KeySets.OrderSet[Order][CurrentFragment] ] << "!" << endl;
+                    performCriticalExit();
                     return false;
                   }
Index: src/periodentafel.cpp
===================================================================
--- src/periodentafel.cpp	(revision 3a0b3890298aafb5853dc67311a7ba037e2e94b4)
+++ src/periodentafel.cpp	(revision 5ae39c416dba574777f0f8f68e7e7f9cacd96a25)
@@ -313,5 +313,5 @@
 
   if (!otherstatus)
-    eLog() << Verbose(0) << "WARNING: Something went wrong while parsing the other databases!" << endl;
+    eLog() << Verbose(2) << "Something went wrong while parsing the other databases!" << endl;
 
   return status;
Index: src/stackclass.hpp
===================================================================
--- src/stackclass.hpp	(revision 3a0b3890298aafb5853dc67311a7ba037e2e94b4)
+++ src/stackclass.hpp	(revision 5ae39c416dba574777f0f8f68e7e7f9cacd96a25)
@@ -72,5 +72,5 @@
     return true;
   } else {
-    eLog() << Verbose(0) << "ERROR: Stack is full, " << "Stack: CurrentLastEntry " << CurrentLastEntry<< "\tCurrentFirstEntry " << CurrentFirstEntry << "\tNextFreeField " << NextFreeField << "\tEntryCount " << EntryCount << "!" << endl;
+    eLog() << Verbose(1) << "Stack is full, " << "Stack: CurrentLastEntry " << CurrentLastEntry<< "\tCurrentFirstEntry " << CurrentFirstEntry << "\tNextFreeField " << NextFreeField << "\tEntryCount " << EntryCount << "!" << endl;
     return false;
   }
@@ -87,5 +87,5 @@
     Walker = StackList[CurrentFirstEntry];
     if (Walker == NULL)
-      eLog() << Verbose(0) << "ERROR: Stack's field is empty!" << endl;
+      eLog() << Verbose(1) << "Stack's field is empty!" << endl;
     StackList[CurrentFirstEntry] = NULL;
     if (CurrentFirstEntry != CurrentLastEntry) { // hasn't last item been popped as well?
@@ -96,5 +96,5 @@
     }
   } else
-    eLog() << Verbose(0) << "ERROR: Stack is empty!" << endl;
+    eLog() << Verbose(1) << "Stack is empty!" << endl;
   return Walker;
 };
@@ -111,10 +111,10 @@
     StackList[CurrentLastEntry] = NULL;
     if (Walker == NULL)
-      eLog() << Verbose(0) << "ERROR: Stack's field is empty!" << endl;
+      eLog() << Verbose(1) << "Stack's field is empty!" << endl;
     NextFreeField = CurrentLastEntry;
     if (CurrentLastEntry != CurrentFirstEntry)  // has there been more than one item on stack
       CurrentLastEntry = (CurrentLastEntry + (EntryCount-1)) % EntryCount; // step back from current free field to last (modulo does not work in -1, thus go EntryCount-1 instead)
   } else {
-    eLog() << Verbose(0) << "ERROR: Stack is empty!" << endl;
+    eLog() << Verbose(1) << "Stack is empty!" << endl;
   }
   return Walker;
@@ -151,5 +151,5 @@
     } while (i!=NextFreeField);
   else
-    eLog() << Verbose(0) << "ERROR: Stack is already empty!" << endl;
+    eLog() << Verbose(1) << "Stack is already empty!" << endl;
   if (found) {
     NextFreeField = CurrentLastEntry;
